/* PenPen Viewer Java(JavaScript) *//*
2003-04-16 orca
  SVGłƂč, PenPenȂ AWT/Swingłł邩,
  }쐬B

2003-04-30 orca
  gEkł[ɂ

2003-05-03 orca
  t@C_CAOtĂ݂B, s̃t@C؂ւ͂łȂ
  ꂩ, ܂`ĂȂucłُ͈I邩

2003-05-08 orca
  ACRtĂ݂
  {^  j[ɕύX

2003-05-14 orca
  r Loadł[ɂ
  , ōŏ̋@\͂ȂB EEE 肠邯ǁB

*/
importPackage(java.lang, java.io, java.util, java.awt, java.awt.event)
importPackage(Packages.javax.swing, Packages.javax.swing.event)
//importClass(java.awt.BorderLayout)
//importClass(java.awt.Dimension)
//importClass(java.awt.Color)


load('PalmPDB.js')

/**
 * PenPenp PDB\f[^ (PenNDB / PenXDB)
 * 2ނ PDB, f[^ځBO͓KɌ߂́B
 */
function PenPenInfo(hed, gap1, frame, line, cnt, gap2) {
  this.headersize = hed
  this._01_size = gap1
  this.framesize = frame
  this.linesize = line
  this.framecount = cnt
  this._02_size = gap2
}

function initPenPenInfo() {
  var tblPenPen = {}
  tblPenPen[PalmPDB.toID('PenN')] = new PenPenInfo(13,  0, 3200, 4, 4, 3)
  tblPenPen[PalmPDB.toID('PenX')] = new PenPenInfo(13, 68, 7200, 6, 4, 3)
  return tblPenPen
}

/**
 * Frame(\p)𓾂ďB
 * j[ACR̃Zbg EEE
 *
 * @param args :Object
 *        .frm :Frame   t[(\)
 *        .cfg :File   vpeB[t@C
 *        .prf :Properties   vpeB[
 * @return :Object   vOp̃uc
 */
function init(args) {
  var ppv = { frame: args.frm, tblPenPen: initPenPenInfo() }
  ppv.frame.iconImage = Toolkit.defaultToolkit.getImage('picon.gif')
  var menuBar = new JMenuBar()
  ppv.frame.setJMenuBar(menuBar)

  var menu = new JMenu('File')
  menu.mnemonic = KeyEvent.VK_F
  //menu.accessibleContext.accessibleDescription = ''
  menuBar.add(menu)

  var menuItem = new JMenuItem('Load...')
  menuItem.mnemonic = KeyEvent.VK_L
  //menuItem.accessibleContext.accessibleDescription = ''
  menu.add(menuItem)

  var obj = {
    actionPerformed: function (evt) { loadPDBFile('') }
  }
  menuItem.addActionListener(new ActionListener(obj))

  var menuItem = new JMenuItem('Export...')
  menuItem.mnemonic = KeyEvent.VK_E
  //menuItem.accessibleContext.accessibleDescription = ''
  menu.add(menuItem)

  var obj = {
    actionPerformed: function (evt) {
      var image = ppv.canvas.createImage(ppv.canvas.width, ppv.canvas.height)
      ppv.canvas.paint(image.graphics)

      var fd = new FileDialog(ppv.frame, 'Save as (jpeg)', FileDialog.SAVE)
      fd.directory = args.prf.getProperty('fdialog.savepath')
      fd.file = '.jpeg'
      fd.show()
      if (fd.file != null) {
        var fname = fd.directory +fd.file
        if (fname.indexOf('.') < 0)
          fname += '.jpeg'

        try {
          var out = new FileOutputStream(fname)
          var enc = Packages.com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(out)
          enc.encode(image)
        }
        finally {
          if (out) out.close()
        }
      }
    }
  }

  /* JPEGCodecgƂł邩ǁ[ EEE */
  try {
    new Class.forName('com.sun.image.codec.jpeg.JPEGCodec')
    menuItem.addActionListener(new ActionListener(obj))
  }
  catch (e) {
    //print(e)
    menuItem.enabled = false
  }

  menu.addSeparator()
  var menuItem = new JMenuItem('Exit')
  menuItem.mnemonic = KeyEvent.VK_X
  //menuItem.accessibleContext.accessibleDescription = ''
  menu.add(menuItem)
  var obj = {
    actionPerformed: function (evt) {
      saveProperties(args.cfg, args.prf)
      quit()
    }
  }
  menuItem.addActionListener(new ActionListener(obj))

  //var button_bar = new JPanel(new FlowLayout(FlowLayout.RIGHT, 0, 0))
  //button_bar.border = BorderFactory.createLoweredBevelBorder()
  //button_bar.add(button)
  return ppv
}

/**
 * PDBt@Cɂ, t@C݂͑邩, TYPE 'Data', `FbNsB
 * st@C_CAO\, t@CIł
 *
 * ppInfo PDB̏񂪃Zbg
 * PPV.frame :Frame   t@C_CAO\ƂɎgp parent
 *
 * @param pdbname :String   (ŏɗ^ꂽ)PDBt@C
 * @return :String   PDBt@CBnull ꂽƂ\
 */
function loadPDBFile(pdbname) {
  for (;;) {
    if (pdbname && new File(pdbname).exists()) {
      var ndb = new PalmPDB(pdbname)
      if (ndb.typeid == PalmPDB.toID('Data')) {
        ppInfo = PPV.tblPenPen[ndb.creatorid]   // global
        //print('OK', ppInfo)
        if (ppInfo != null) break;
      }
    }

    var fd = new FileDialog(PPV.frame, 'Open: PenPen PDB')
    fd.directory = prop.getProperty('fdialog.readpath')
    fd.file = '*.pdb'
    fd.show()
    if (fd.file == null)
      return null

    prop.put('fdialog.readpath', fd.directory)
    pdbname = fd.directory +fd.file
  }

  ppInfo.ndb = ndb

  var listModel = new DefaultListModel()
  for (var i = 0; i < ppInfo.ndb.records.length; i++) {
    listModel.addElement('Rec '+i +':1')
    listModel.addElement('Rec '+i +':2')
    listModel.addElement('Rec '+i +':3')
    listModel.addElement('Rec '+i +':4')
  }
  PPV.list.model = listModel

  return pdbname
}


/**
 * Byte Array𐔒lɕϊ
 *
 * @param ba :byte[]   bynary data (byte array)
 * @param st :Number   ϊJnʒu (0;擪)
 * @param ln :Number   ϊ钷
 * @return :Number   ϊʂ̐l
 */
function baToNumber(ba, st, ln) {
  if (arguments.length == 1)
    st = 0, ln = ba.length

  if (arguments.length == 2)
    ln = st, st = 0

  var res = 0
  for (var i = 0; i < ln; i++) {
    res <<= 8;
    res += ba[st +i] & 0xff   // b >= 0? b: 256 +b
  }

  return res
}

var A_COLOR = Array('ff', 'cc', '99', '66', '33', '00')
var A_GRAY = Array('00', '22', '44', '66', '88', 'aa', 'cc', 'ee')
/**
 * 256F̃R[h 0xRRGGBB`ɕϊ
 * , ܂sȕ (O[ȂƂƂ)
 *
 * @param n :Number   FR[h(0 - 255)
 * @return :Number   0xRRGGBB`̐FR[h
 */
function toFullColor(n) {
  var col
  if (n < 216) {
    var cG = n %6; n = Math.floor(n /6);
    var cB = n %3; n = Math.floor(n /3);
    var cR = n %6; n = Math.floor(n /6);
    cB = cB +n *3
    col = '0x'+A_COLOR[cR]+A_COLOR[cG]+A_COLOR[cB]
    return Number(col)
  }

  n -= 216
  if (n < 8) {
    var tmp = A_GRAY[n]
    col = '0x'+tmp+tmp+tmp
    return Number(col)
  }

  return 0x000000
}

/**
 * PenPen PDB, w肳ꂽʂ̃f[^o
 * tB[hɃZbgB
 *
 * ppInfo
 *
 * @param cv :Canvas?   `ێƂ
 * @param rno :Number   R[hԍ (0 -)
 * @param frm :Number   t[ԍ (0 - 3)
 */
function loadVectorData(cv, rno, frm) {
  var ba = ppInfo.ndb.records[rno]
  var pHead = ppInfo.headersize +ppInfo._01_size
  var st = pHead +ppInfo.framesize *ppInfo.framecount +ppInfo._02_size +4 *frm
  var nVect = baToNumber(ba, st, 4)   // ̐
  //print(nVect)

  var p = pHead +ppInfo.framesize *frm
  var limit = p +Math.min(ppInfo.framesize, nVect *ppInfo.linesize)

  cv.px1 = [], cv.py1 = [], cv.px2 = [], cv.py2 = [];
  cv.lineColor = [], cv.lineType = [];

  for (var i = 0; p < limit; i++, p += ppInfo.linesize) {
    var pp = p +ppInfo.linesize
    var col = ppInfo.linesize > 4?
                toFullColor(ba[p+1] & 0xff): 0x000000

    cv.px1[i] = ba[pp -4] & 0xff
    cv.py1[i] = ba[pp -3] & 0xff
    cv.px2[i] = ba[pp -2] & 0xff
    cv.py2[i] = ba[pp -1] & 0xff
    cv.lineColor[i] = new Color(col)
  }
}

/**
 * R|[lg̍쐬
 *
 * @param ppv :
 * @return :Component   R|[lg
 */
function createComponents(ppv) {
  /* const */ var SCR_WIDTH=150
  /* const */ var SCR_HEIGHT=150
  var pane = new JPanel(new BorderLayout())

  ppv.canvas = new JavaAdapter(JPanel, {
      px1: [], py1: [], px2: [], py2: [],
      lineColor: [], lineType: [],

      paint: function (g) {
        g.color = this.background
        g.fillRect(0, 0, this.width, this.height)

        var rate = Math.min(this.width /SCR_WIDTH, this.height /SCR_HEIGHT)

        for (var i = 0; i < this.px1.length; i++) {
          g.color = this.lineColor[i]
          g.drawLine(this.px1[i] *rate, this.py1[i] *rate,
                     this.px2[i] *rate, this.py2[i] *rate)
        }
      }
  })

  ppv.canvas.setPreferredSize(new Dimension(SCR_WIDTH, SCR_HEIGHT))
  ppv.canvas.background = Color.white
  // ppv.canvas.opaque = true

  ppv.list = new JList()
  ppv.list.selectionMode = ListSelectionModel.SINGLE_SELECTION
  ppv.list.addListSelectionListener(new ListSelectionListener() {
      prevSelValue: -1,
      valueChanged: function (evt) {
        var sel = evt.source.selectedIndex
        if (sel >= 0 && sel != this.prevSelValue) {
          this.prevSelValue = sel

          loadVectorData(ppv.canvas, Math.floor(sel/4), sel %4)
          ppv.canvas.repaint()
        }
      }
  })

  listScrollPane = new JScrollPane(ppv.list)
  listScrollPane.setPreferredSize(new Dimension(80, SCR_HEIGHT))
  if (false) {
    pane.add(
        new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, listScrollPane, ppv.canvas),
        BorderLayout.CENTER)
  }
  else {
    pane.add(listScrollPane, BorderLayout.WEST)
    pane.add(ppv.canvas, BorderLayout.CENTER)
  }

  return pane
}


/**
 * vpeB[(vO)̓ǂݍ
 *
 * @param cfgfile :File   vpeB[t@C
 * @return :Properties   ǂݍ񂾃vpeB[
 */
function loadProperties(cfgfile) {
  var prop = new Properties()
  try {
    var ins = new FileInputStream(cfgfile)
    prop.load(ins)
  }
  catch (e) {}
  finally {
    if (ins != null)
      ins.close()
  }

  return prop
}

/**
 * vpeB[(vO)̏
 *
 *  'frame'
 * framewindoẅʒuωƂ, I propύXĂ
 * , ꂪύXꂽďǂɎĂ,  framegȂĂ悢
 *
 *
 * @param cfgfile :File   vpeB[t@C
 * @param prop :Properties   ޓe
 */
function saveProperties(cfgfile, prop) {
  prop.put('frame.pos', frame.getLocation().toString())

  try {
    var outs = new FileOutputStream(cfgfile)
    prop.save(outs, 'PenPen Viewer properties')
  }
  finally {
    if (outs != null)
      outs.close()
  }
}


/**
 * Main
 */
var cfgfile = new File('SPenPen.cnf')
var prop = loadProperties(cfgfile)

try {
  UIManager.setLookAndFeel(UIManager.systemLookAndFeelClassName)
}
catch (e) {
}

var frame = new JFrame(prop.getProperty('frame.title', 'PenPen Viewer'))
frame.addWindowListener(new WindowAdapter() {
    windowClosing: function (evt) {
      saveProperties(cfgfile, prop)
      quit()
    }
})

var str = prop.getProperty('frame.pos')
if (str) {
  var xy = str.match(/x=(\d+),y=(\d+)/)
  if (xy) frame.setLocation(xy[1], xy[2])
}

var PPV = init({ frm: frame, cfg: cfgfile, prf: prop })   // global
frame.contentPane.add(createComponents(PPV))
frame.pack()
frame.visible = true

if (!loadPDBFile(arguments[0]))
  quit()

/* -- End of Script -- */
